;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************

	TITLE           "GNU-link : CD-Multichanger Emulation"
	SUBTITLE        "Released under the GPL license, (c) S Wood, Oct 2001"

;******************************************************************************
;	Additional Info - Release version  1.8T_02
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, June 2004"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************
; GNUnilink Configuration.
; Uncomment the lines relevant to your board... 
; this should be only configuration required.
;
; Type of PIC
#define		PIC_16F628

; Speed (or closet)
;;--- Only "20MHz" is available.  (T)
#define		SPEED_20MHZ

;******************************************************************************
;;--- CD/MD manual setting		;; Feb. 21 2004  (T)
;;   If You want to select CD/MD mode by Hardware switch manually,
;;   Please Set Here.  (Comment out means Auto-select. default:MD)

;;#define		CdMd_SW

;;-----------------------------------------------------
;;--- Next Disc 			;; Apr. 25 2004 (T)
;;   If You want to remap AS buttom to NextDisc,
;;   Please Set Here.  (Commentout means NOT remap)
;;   (this function is espacially for MDX-5V101R with CD/MD changer)

#define		NextNext

;;-----------------------------------------------------
;;--- Internal_MD flag			;; Jul. 25 2004 (T)
;;   Priventing dongle to play followed by the internal MD.
;;   MDX-5V101R is able to handle one internal and one external
;;   MD chnager.  And HU automatically selects to play external 
;;   MD chnager followed by the the playing of internal one.
;;   If you do NOT want this automatic selection, when dongle emulates
;;   as an external MD chnager, Please Set Here.

#define		Internal_MD

;******************************************************************************
;;--- DEBUG Mode		;; Feb. 15 2004  (T)
				;; If you want to Release Version, 
;;#define	DEBUG			;; Comment Out This line.
				;;
;******************************************************************************
; Real settings for the PIC - if you need to add a new one do it here, 
; otherwise select one from above

		Radix   DEC
		EXPAND

	IFDEF	PIC_16F628
		Processor       16f628
		include         "p16f628.inc"

;; changed to WDT-OFF for TMR0 interrupt (T) 
	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC & _WDT_OFF

#define		PIC_16F62x
#define		PIC_16
	ENDIF

	IFDEF	PIC_16
#define		OUT_PORT	PORTA
#define		OUT_ENA		TRISA
	ENDIF

;******************************************************************************
; A few standard definitions

_ResetVector	set	0x00
_IntVector      set     0x04

TRUE	equ	1
FALSE	equ	0

;******************************************************************************
; Timing Calibration Values - These are non critical in that they don't have 
; to be absolutely correct, but it's nicer to be almost right if you can....

; 100us delay loop is 8 + (n * 7) cycles.

;; Only SPEED_20MHZ should be available for the stability 
;; Baud rate should also be set higher rate, as possible. (T)

	IFDEF	SPEED_20MHZ
#define		delay100us	70
#define		baud_val	10	; 113363 baud(115K) ;; Dec.21 2003 (T)
	ENDIF

;******************************************************************************
;                               Setup Register Locations
;; -------------- REGISTER BANK 0 ----- 0x20 - 0x6f ---------
Cmd1		set		0x20
Cmd2		set		0x21
Data11		set		0x22
Data12		set		0x23
Data13		set		0x24
Data14		set		0x25
Data21		set		0x26
Data22		set		0x27
Data23		set		0x28
Data24		set		0x29
Data25		set		0x2a
EndByte		set		0x2b
MyGroup		set		0x2c
Parity1		set		0x2d
Parity2		set		0x2e
Time0		set		0x2f
Time1		set		0x30
TrackNum	set		0x31
status_store	set		0x32	; stores STATUS reg during interrupt
w_store		set		0x33	; stores w reg during interrupt

;;---------Following Registers are added by Turboh ---------
Appoint_Now	set		0x34
Count3		set		0x35
DDir_Flag	set		0x36
DDir_Num	set		0x37
DSPL_Run	set		0x38
DSPL_ToggleC	set		0x39
DiscNam_DSPL	set		0x3a
DiscNamADDR	set		0x3b
Display		set		0x3c
Display_Route	set		0x3d
DropCheckCount	set		0x3e
Dsp_Field	set		0x3f
EeRet		set		0x40
EepromChrAdd	set		0x41
Ej_announceF	set		0x42
GetMyG_Count	set		0x43
IdleState	set		0x44
Int1secON	set		0x45
Int1sec_Count	set		0x46
MD11State	set		0x47
MyIdCont_Flag	set		0x48
NeedToTalk	set		0x49
NewDiscNumP	set		0x4a
NewDiscNumR	set		0x4b
PCNT		set		0x4c
PCNT2		set		0x4d
PCNT3		set		0x4e
PowDown		set		0x4f
ResPeriod	set		0x50
Res_AppEnd_flag	set		0x51
Sleeping	set		0x52
SlotOfMag	set		0x53
SlotOfMagP	set		0x54
SlotOfMg_Cd	set		0x55
SlotOfMg_Md	set		0x56
SubWork		set		0x57
SubWork2	set		0x58
TMR1H_SetData	set		0x59
TMR1L_SetData	set		0x5a
Tad		set		0x5b
Time0i		set		0x5c
Time1i		set		0x5d
Time1iT		set		0x5e
Timep		set		0x5f
TrackNamADDR	set		0x60
TrackNum_Tmp	set		0x61

;;---DEBUG
Test_Data	set		0x62		;; for DEBUG ;;
;;---

;; ---------- COMMON (shared) REGISTERS -- 0x70 - 0x7f ------
Checksum	set		0x70
Count		set		0x71
Count2		set		0x72
CurDiscNum	set		0x73
DataVal		set		0x74
DiskNum		set		0x75
DispCtrl	set		0x76
MyBit		set		0x77
MyId		set		0x78
Rad		set		0x79
TrackNum_Dsp	set		0x7a
CurSource	set		0x7b
ee_data		set		0x7c


;;--------------Following Values are added by Turboh ----------------
;; -- Please adjust for Your Hardware.
;; for TMR1 interrupt			;; May 22 2004 (T)
;;    Hardware Timer = 62610,  Software Timer = 10
;;	65536-62610=2926 = 0xb6e 	;; Adjusted May 29 2004 (T)
TMR1H_SetData	set		0x0b ;; TMR1H initial (=11)
TMR1L_SetData	set		0x6e ;; TMR1L initial (=110)
Int1sec_Data	set		0x0a ;; Software counter initial (=10)
;Int1sec_Data	set		0x01 ;; Software counter initial (=1)[DEBUG]
;Int1sec_Data	set		0x05 ;; Software counter initial (=5)[DEBUG]

;******************************************************************************
; Port definitions, which signal is where on the OUT_PORT

#define		DataBit		0
#define 	ClockBit	1
#define		BusOnBit	2
#define 	CdNotMdBit	3
#define		LEDBit		3	;; Port_B    Feb.14 2004 (T)
#define		BusOnOut	2	;; Port_B    Apr.04 2004 (T)
#define		Rel_Set		5	;; Port_B    Apr.04 2004 (T)

;******************************************************************************
;;--- Device ID
; Default definitions for responses, these may need to be changed for
; your HEADUNIT.

#define		MDX_61			;;MDX-61(MDX-5G01)
;#define		CDC1
;#define		MDC2

;;;;-----------------------------------------------
	IFDEF	MDX_61
Anyone_0	set		0x8c ;; MDX-61(MDX-5G01) (T)
Anyone_1	set		0x60
Anyone_2	set		0x06
Anyone_3	set		0x68
Anyone_4	set		0x02
Anyone_5	set		0x00

Appoint_0	set		0x8c ;; MDX-61(MDX-5G01) (T)
Appoint_1	set		0x60
Appoint_2	set		0x06
Appoint_3	set		0x68
Appoint_4	set		0x02
Appoint_5	set		0x00
	ENDIF
;;;;-----------------------------------------------
	IFDEF	CDC1
Anyone_0	set		0x8c ;; CDX-605, CDX-91 (by Mic)
Anyone_1	set		0xa0
Anyone_2	set		0x06
Anyone_3	set		0xab
Anyone_4	set		0x25
Anyone_5	set		0xa0

Appoint_0	set		0x8c
Appoint_1	set		0xa0
Appoint_2	set		0x06
Appoint_3	set		0xab
Appoint_4	set		0x25
Appoint_5	set		0xa0
	ENDIF
;;;;-----------------------------------------------
	IFDEF	MDC2
Anyone_0	set		0x8c ;; No name (by Mic)
Anyone_1	set		0x00
Anyone_2	set		0x24
Anyone_3	set		0x2c
Anyone_4	set		0x22
Anyone_5	set		0xa0

Appoint_0	set		0x8c
Appoint_1	set		0x00
Appoint_2	set		0x24
Appoint_3	set		0x2c
Appoint_4	set		0x22
Appoint_5	set		0xa0
	ENDIF

;******************************************************************************
; Value of Display_Route

GoThreeLoop	set		0x33		;; 3 -> 3 -> 3..
GoDNandThL	set		0x63		;; 6 -> 7 -> 3 -> 3...

;******************************************************************************

DispCtrl_Init	set		0x0e	;; (default)
DispCtrl_Start	set		0x0d	;; display DiscName
;DispCtrl_Start	set		0x0f	;; display TrackName
;DispCtrl_Start	set		0x0c	;; display Nothing
;DispCtrl_Start	set		0x0b	;; display TrackName
DispCtrl_Inform	set		0x0e	;; Inform to HU (Not display Disc/Track names)

;******************************************************************************
; Value of EEPROM ADDR for CD/MD MagInfoADDR

MagCD_EEADR	set		0x10	;; EEPROM ADDR for Mag_CD(0x2110)
MagMD_EEADR	set		0x11	;; EEPROM ADDR for Mag_MD(0x2111)

;******************************************************************************
; Value of memorized MyGroup (CD or MD) in EEPROM

MyGroupEEADR	set		0x12	;; EEPROM ADDR for CD/MDgroup(0x2112)


;******************************************************************************
; Value of EEPROM ADDR for DiscName and TrackName

DiscNamADDR0	set		0x20		;; EEPROM:0x2120
DiscNamADDR1	set		0x30		;; EEPROM:0x2130
TrackNamADDR0	set		0x40		;; EEPROM:0x2140
TrackNamADDR1	set		0x40		;; EEPROM:0x2140 (=ADDR0)

;******************************************************************************
; Start of code space

	ORG     _ResetVector
	goto	SystemSetup

;******************************************************************************
	include "interrupt.asm"
	include "functions.asm"
	include "setup.asm"
	include "receive.asm"
	include "parse.asm"
	include	"respond.asm"
	include "display.asm"

;******************************************************************************
; EEPROM data
	ORG     0x2100			;; hex version number
	DE	"040808sim20"
;; --- 0x2110 to  0x211f are reserved --- ;;
;; -------------------------------------- ;;
	ORG     0x2120			;; Disk Name #1
	DE	"<AUX-IN>   <-- "
	ORG     0x2130			;; Disk Nmae #2
	DE	"VW-Maniacs <-- "
	ORG     0x2140			;; Track Name #1
	DE	"Not Obsessed wit"
	ORG     0x2150			;; Track Name #2
	DE	"h your VW?  That"
	ORG     0x2160			;; Track Name #2
	DE	"'s OK. you are s"
	ORG     0x2170			;; Track Name #2
	DE	"till welcome."

;******************************************************************************

	END
