;;*****************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
;	Additional Info - Release version  1.8T_02
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, June 2004"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************
; Sequenced responses to the Slave Poll, called so that the screen is updated.
;;--- NOTE				;; Feb. 11 2004  (T)
;; Meaning of Displays are little changed to meet "State-transition-model".
;; Since the "Display" is incremented in the next transition process
;; in the original code, I modified to set it in the end of every transition
;;      "Present_State_Num" + "Event" ==>[proc]==> "Next_State_Num"
;;    It's easy to read...

Respond_SlavePoll:			;; [permission to talk]
	movf	MyId, 0			; Check it's the right ID
	xorwf	Rad, 0			;;      Apr. 24 2004 (T)
	btfss	STATUS, Z
	goto	ReceiveBreak		; Done, wait for next command

	clrf	Checksum 		; Clear checksum

	movf	Display, 0
	xorlw	0x01			;; 1/16 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_1

	movf	Display, 0
	xorlw	0x02			;; 1/16 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_2

	movf	Display, 0
	xorlw	0x03			;; 1/16 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_3

	movf	Display, 0
	xorlw	0x04			;; 7/30 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_4

	movf	Display, 0
	xorlw	0x05			;; 7/30 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_5

	movf	Display, 0
	xorlw	0x06			;; 3/4 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_6

	movf	Display, 0
	xorlw	0x07			; Check if 7th response
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_7

	movf	Display, 0
	xorlw	0x08			; Check if 8th response
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_8

	movf	Display, 0
	xorlw	0x09			; Check if 9th response
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_9

	movf	Display, 0
	xorlw	0x0a			; Check if 10th response
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_a


	movf	Display, 0
	xorlw	0x0c			; Check if 12th response
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_c


	IFDEF	NextNext
;;--- NEXT NEXT	------------------	;; Apr. 18 2004 (T)
	movf	Display, 0
	xorlw	0x10			;; =16
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_16
;;--------------------------------
	ENDIF

	IFDEF	Internal_MD
;;--------------------------------	;; Jul. 25 2004 (T)
	movf	Display, 0
	xorlw	0x20			;; =32
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_32
;;--------------------------------
	ENDIF

	goto	ReceiveBreak		; should NEVER get here!!


Respond_SlavePoll_1:
	movlw	0x77			; 'Seeking CD'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xc0
	call	SendByte

	movlw	0x40
	call	SendByte

	call	Checksum_mid

	call	SendByte3_00

	movlw	0x00
	call	SendByte

	movf	MyGroup, 0		;;
	xorlw	0x30
	movlw	0x50            	;; for MD ("0x50":DiscName and TrackName)
	btfsc	STATUS, Z
	movlw	0x40			;; for CD ("0x40":DiscName Only)
	call	SendByte

	movf	TrackNum_Dsp, 0		;; Track Number  Feb. 21 2004 (T)
	call	SendByte

	movlw	0x00			;; Min
	call	SendByte

	movlw	0x00			;; Sec
	call	SendByte

	swapf	DiskNum, 0		; Disk Number + disp code
	iorlw	0x01			;; DispCtrl=0x01
	call	SendByte

	call	Respond_End_R

	clrf	Timep			;; Time Counter reset (T)
	clrf	Time0			;; 
	clrf	Time1			;; 
	clrf	Time0i			;; 
	clrf	Time1i			;; 

	bcf	INTCON, GIE		;; Disable interrupt  Feb. 05 2004 (T)

	call	RelSet_ON		;; Apr. 07 2004 (T)
	bsf	DSPL_Run, 0		;; set DSPL_Run flag ON

Config_TMR1_2:				;; setup TMR0
	movlw	Int1sec_Data	  	;; Int1sec_Data -> Int1sec_Count
	movwf	Int1sec_Count	  	;; (software counter)

	movlw	TMR1H_SetData		;; set TMR1H initial
	movwf	TMR1H

	movlw	TMR1L_SetData		;; set TMR1H initial
	movwf	TMR1L

	bcf	PIR1, TMR1IF		;; clear overflow flag

;;--- Disable Interrpt until DiscName Displaying has been completed  (T)
	bcf	INTCON, GIE		;; Disable GEIE Interrupt
	nop
	bcf	INTCON, PEIE		;; Disable PEIE Interrupt

	bsf	STATUS, RP0		;; go to Bank1
	bcf	PIE1, TMR1IE		;; Disable TMR1 Inerrupt
	bcf	STATUS, RP0		;; back to Bank0

	bcf	T1CON, TMR1ON		;; set TMR1ON = Stop


But_DSPL_Ent2:
	movlw	0x02			;; Next State Number=2
	movwf	Display

	bsf	ResPeriod, 0		;; (set ResPeriod = 1)

	call	IssueSlaveBreak		;;

	goto	ReceiveBreak


Respond_SlavePoll_2:			
	movlw	0x70			; 'Seeking to Track'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xc0
	call	SendByte

	movlw	0x00			;; 00 Seeking
	call	SendByte

	call	Checksum_mid

	call	SendByte3_00

	movlw	0x00
	call	SendByte

	movf    MyGroup, 0		;;
	xorlw   0x30
	movlw   0x50            	;; for MD ("0x50":DiscName and TrackName)
	btfsc   STATUS, Z
	movlw	0x40			;; for CD ("0x40":DiscName Only)
	call	SendByte
	
	movf	TrackNum_Dsp, 0		;; Track Number Feb. 21 2004 (T)
	call	SendByte

	movf	Time1, 0		; Track Timer  (minutes)
	call	SendByte

	movf	Time0, 0		; Track Timer  (seconds)
	call	SendByte

	swapf	DiskNum, 0		; Disk Number + disp code
	iorwf	DispCtrl, 0
	call	SendByte

	call	Respond_End_R



But_DSPL_Ent:
	movf	MyGroup, 0		
	xorlw	0x30			;; case CD/MD?
	movlw	0x04			;; Next State Number=4 (MD)
	btfsc	STATUS, Z
	movlw	0x06			;; Next State Number=6 (CD)
	movwf	Display

	bsf	ResPeriod, 0		;; (set ResPeriod = 1)

	call	IssueSlaveBreak		;; call ISB

	goto	ReceiveBreak		; Done, wait for next command

	
Respond_SlavePoll_3:
	clrf	Int1secON		;; June 05 2004 (T)

	movlw	DispCtrl_Inform
	movwf	DispCtrl		

	movlw	0x70			; "CD d, Track t, mm:ss"
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0x90
	call	SendByte

	movf	MyGroup, 0		;;
	xorlw	0x30
	movlw	0x50            	;; for MD ("0x50":DiscName and TrackName)
	btfsc	STATUS, Z
	movlw	0x40			;; for CD ("0x40":DiscName Only)
	call	SendByte

	call	Checksum_mid

	movf	TrackNum_Dsp, 0		;; Track Number   Feb. 21 2004 (T)
	call	SendByte

	movf	Time1, 0		; Track Timer  (minutes)
	call	SendByte

	movf	Time0, 0		; Track Timer  (seconds)
	call	SendByte

	swapf	DiskNum, 0		; Disk Number + Disp code
	iorwf	DispCtrl, 0
	call	SendByte

	call	Respond_End_R

	bcf	INTCON, GIE		;; Disable interrupt  Feb. 05 2004 (T)

	movlw	0x03			;; Next State Number=3
	movwf	Display

	bsf	ResPeriod, 0		;; set ResPeriod = 1

;;-- DiscName auto display --
	movf	MyGroup, 0		;; case MD Only.
	xorlw	0x30
	btfsc	STATUS, Z
	goto	SLP3_B			;; case CD, Skip

	btfsc	Time1, 0		; check TrackTimer is 0,2,4,6,8,10...
	goto	Skip08			;; Not 0,2,4,6,8,10, Exit

	movf	Time0, 0		; Track Timer  (seconds)
	xorlw	0x00			;; BCD expression "00"
	btfss	STATUS, Z
	goto	Skip08			;; not 00, Exit

	movlw	0x08			;; set Display=8
	movwf	Display			;; 

	bsf	DSPL_Run, 0		;; set DSPL_Run flag ON
	goto	Skip082

Skip08:
	movf	MyGroup, 0		;; case MD only.
	xorlw	0x30			
	btfsc	STATUS, Z
	goto	SLP3_B			;; case CD, Skip
					
	btfss	DSPL_Run, 0		;; case MD
	goto	SLP3_B			;; case DSPL_Run = OFF, Skip.

					;; case DSPL_Run = ON, 
	movf	Time0, 0		;  Track Timer  (seconds)
	xorlw	0x07			;; Displaying Period (7sec) (BCD expression) 
	btfss	STATUS, Z
	goto	SLP3_B

	movf	Time1, 0
	andlw	0x03
	xorlw	0x02			;; check TrackTimer is 2,6,10,...(min.)
	btfss	STATUS, Z
	goto	Skip080			;; else, Skip

	movlw	DiscNamADDR0		;; EEPROM:0x2120
	movwf	DiscNamADDR
	movlw	TrackNamADDR0		;; EEPROM:0x2140
	movwf	TrackNamADDR

	goto	Skip081

Skip080:
	movf	Time1, 0
	andlw	0x03
	xorlw	0x00			;; check TrackTimer is 4,8,12,...
	btfss	STATUS, Z
	goto	Skip082			;; else, Skip

	movlw	DiscNamADDR1		;; EEPROM:0x2130
	movwf	DiscNamADDR
	movlw	TrackNamADDR1		;; EEPROM:0x2140
	movwf	TrackNamADDR

Skip081:
	movlw	0x09			;; case Time0="5", set Display=9
	movwf	Display			;; 
	bcf	DSPL_Run, 0		;; set DSPL_Run flag OFF

Skip082:
	call	Int_Enaset		;; Enable Interrpt
	movf	Display, 0
	xorlw	0x03			;; Display=3?
	btfss	STATUS, Z
	call	IssueSlaveBreak		;; Not Display=3, then call ISB.
					;; Display=3, Skip ISB. (goto SLP3_B)
SLP3_B:
	btfsc	PowDown, 0		;; 
	goto	Play_Stop_RE		;; case Power Down 
					;; else, Continue
	call	Int_Enaset		;; Enable Interrpt

	goto	ReceiveBreak

Play_Stop_RE:
	bcf	INTCON, GIE		;; Disable GEIE Interrupt
	call	Play_Stop		;; case PowerDown, Stop Playing

	goto	ReceiveBreak

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Respond_SlavePoll_4:
	movlw	0x70				; 'Track name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xC9
	call	SendByte

	movf	TrackNamADDR, 0		;; TrackNamADDR -> W
	movwf	EepromChrAdd		;; set ;; TrackNamADDR

	call	SendEepromChrs

	movf	TrackNum_Dsp, 0		;; Track Number
	call	SendByte

	movlw	0x00			;; 1st time. (high nibble=0)
	iorwf	DispCtrl, 0		;; 
	andlw	0xf3			;; mask with '11110011'
	call	SendByte

	call	Respond_End_R

	movlw	0x05			;; Next State Number=5
	movwf	Display

	bsf	ResPeriod, 0		;; set ResPeriod=1

	call	IssueSlaveBreak		;; call ISB

	goto	ReceiveBreak		; Done, wait for next command


Respond_SlavePoll_5:
	movlw	0x70				; 'Track name, part2'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xC9
	call	SendByte

	call	SendEepromChrs

	movf	TrackNum_Dsp, 0		;; Track Number   Feb. 21 2004 (T)
	call	SendByte

	movlw	0x10			;; 2nd time. (high nibble=1)
	iorwf	DispCtrl, 0		;; 
	andlw	0xf3			;; mask with '11110011'
	call	SendByte

	call	Respond_End_R

	movlw	0x06			;; Next State Number=6 (CD)
	movwf	Display

	bsf	ResPeriod, 0		;; (set ResPeriod = 1)

	call	IssueSlaveBreak		;; call ISB

	goto	ReceiveBreak		; Done, wait for next command


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Respond_SlavePoll_6:
	movlw	0x70			; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xCD
	call	SendByte

	movf	DiscNamADDR, 0		;; DiscNamADDR -> W
	movwf	EepromChrAdd		;; set ;; DiscNamADDR

	call	SendEepromChrs

	movf	DiskNum, 0 		;; Disc Number
	call	SendByte

;;--------- for MDX-5V101R, for MDX-61    Mar. 06 2004 (T)
	movlw	0x00			;; 1st time. (high nibble=0)
	iorwf	DispCtrl, 0		;; 
	andlw	0xf3			;; mask with '11110011'
	call	SendByte

	call	Respond_End_R

	movlw	0x07			;; Next State Number=7
	movwf	Display

	bsf	ResPeriod, 0		;; set ResPeriod = 1

	call	IssueSlaveBreak		;; call ISB

	goto	ReceiveBreak		; Done, wait for next command


Respond_SlavePoll_7:
	movlw	0x70			; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xCD
	call	SendByte

	call	SendEepromChrs

	movf	DiskNum, 0 		;; Disc Number
	call	SendByte

;;------- for MDX-5V101R, and for MDX-61    Mar. 06 2004 (T)
	movlw	0x10			;; 2st time. (high nibble=1)
	iorwf	DispCtrl, 0		;; 
	andlw	0xf3			;; mask with '11110011'
	call	SendByte

	call	Respond_End_R


DSP_Rt_Ent:
	movlw	0x03			;; Next State Number=3
	movwf	Display

	bsf	ResPeriod, 0 		;; (set ResPeriod = 1)
			
	call	Int_Enaset		;; Enable Interrpt

	goto	ReceiveBreak		; Done, wait for next command


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Respond_SlavePoll_8:			;; Display shows Disc name
					;; [18,11,80,19,0a,00,00,00]
	movlw	0x18		;; 
	call	SendByte

	movlw	0x11		;; 
	call	SendByte

	movlw	0x80
	call	SendByte

	movlw	0x19			;; Show	Disc name
	call	SendByte

	call	Checksum_mid

	movlw	0x0a
	call	SendByte

	call	SendByte3_00

	call	Respond_End_R

	movlw	0x03
	movwf	Display

	bsf	ResPeriod, 0 		;; (set ResPeriod = 1)

	goto	ReceiveBreak		; Done, wait for next command


;;--
Respond_SlavePoll_9:			;; Display shows Track Time
					;; [18,11,80,09,0a,00,00,00]
	movlw	0x18		;; 
	call	SendByte

	movlw	0x11		;; 
	call	SendByte

	movlw	0x80
	call	SendByte

	movlw	0x09		;; Show	Track Time
	call	SendByte

	call	Checksum_mid

	movlw	0x0a
	call	SendByte

	call	SendByte3_00

	call	Respond_End_R

	goto	But_DSPL_Ent2


;;---				;; 'Track name' (Extra)
Respond_SlavePoll_a:		;;70,Tad,d9,xx,xx,xx,xx,xx,xx,xx,xx,01,(field)
	IFDEF	DEBUG
;;--DEBUG setting --------
	incf	DiskNum,  1	;; 
;;------------------------
	ENDIF

	movlw	0x70			
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xD9
	call	SendByte

	movf	Dsp_Field, 0		;; copy to SubWork (work)
	movwf	SubWork2			;; 
	nop
	bcf	STATUS, C		;; clear C flag before rotation
	rlf	SubWork2, 1		;; rotate left 1 time (*2)-> REG
	nop
	rlf	SubWork2, 1		;; rotate left 2 time (*4)-> REG
	nop
	rlf	SubWork2, 0		;; rotate left 3 time (*8)-> W
	andlw	0xf8			;; mask with '11111000'

	addwf	TrackNamADDR, 0		;; TrackNamADDR + (8*field) -> W
	movwf	EepromChrAdd		;; set ;; TrackNamADDR

	call	SendEepromChrs

	movf	TrackNum_Dsp, 0		;; Track Number
	call	SendByte

	movf	Dsp_Field, 0		;; Dsp_Field -> W
	call	SendByte

	call	Respond_End_R

	goto	DSP_Rt_Ent

;;--
				;; 'Disc name, part1' (Extra)
Respond_SlavePoll_c:		;;70,Tad,dd,xx,xx,xx,xx,xx,xx,xx,xx,0f,(field)
	movlw	0x70			; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xdd
	call	SendByte

	movf	Dsp_Field, 0		;; copy to SubWork (work)
	movwf	SubWork2			;; 
	nop
	bcf	STATUS, C		;; clear C flag before rotation
	rlf	SubWork2, 1		;; rotate left 1 time (*2)-> REG
	nop
	rlf	SubWork2, 1		;; rotate left 2 time (*4)-> REG
	nop
	rlf	SubWork2, 0		;; rotate left 3 time (*8)-> W
	andlw	0xf8			;; mask with '11111000'

	addwf	DiscNamADDR, 0		;; DiscNamADDR + (8*field) -> W
	movwf	EepromChrAdd		;; set ;; DiscNamADDR

	call	SendEepromChrs

	movf	DiskNum, 0 		;; Disc Number
	call	SendByte

	movf	Dsp_Field, 0		;; Dsp_Field -> W
	call	SendByte

	call	Respond_End_R

	goto	DSP_Rt_Ent


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	IFDEF	NextNext

;;--- NEXT NEXT----------------		;; Apr. 18 2004  (T)
;;--  Changed to send [Tad,11,b0,Num,ff,00,00,00]
Respond_SlavePoll_16:			;; label changed Apr. 18 2004 (T)
	movf	CurSource, 0
	call	SendByte

	movlw	0x11			;; 
	call	SendByte

	movlw	0xb0			;; Direct Num
	call	SendByte

	movf	CurDiscNum, 0		;; CurDiscNum (= new DiscNum)
	call	SendByte

	call	Checksum_mid

	movlw	0xff
	call	SendByte

	call	SendByte3_00

	call	Respond_End_R

	clrf	Display			;; set Next State Number=0
	clrf	ResPeriod		;; set ResPeriod=0
	bsf	PowDown, 0		;; PowerDown!!

	goto	ReceiveBreak		; Done, wait for next command

;;-------------------------------
	ENDIF	;;<NextNext>


	IFDEF	Internal_MD
;;--------------------------------	;; Jul. 25 2004 (T)
Respond_SlavePoll_32:		;; [77 MyId 8e c0 00 00 00 f0] (No magazine)
	movlw	0x77		;; 
	call	SendByte		;; Rad

	movf	MyId, 0			;; Tad
	call	SendByte

	movlw	0x8e			;; Cmd1
	call	SendByte

	movlw	0xc0			;; Cmd2
	call	SendByte

	call	Checksum_mid

	call	SendByte3_00

	movlw	0xf0			;; D4
	call	SendByte

	call	Respond_End_R

	clrf	Display			;; set Next State Number=0
	clrf	ResPeriod		;; set ResPeriod=0
	bsf	PowDown, 0		;; PowerDown!!

	goto	ReceiveBreak		; Done, wait for next command
;;--------------------------------
	ENDIF	;;Internal_MD


;;---
SendEepromChrs:
	call	RetEepromChr
	call	SendByte

	call	Checksum_mid

	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte
	
	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte

	return

;;---
Checksum_mid:
	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum

	return

;;---
SendByte3_00:			;; successively "SendByte 0x00" by three times 
	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	return

;;*****************************************************************************
;;----- End of display.asm
